#!/bin/sh

 CPP=g++
 TOP_DIR=../..
 CXXFLAGS="-c -Wall -O2 -I$TOP_DIR/"

 rm -rf $TOP_DIR/MGXSUtils/MatxsUtils/MatxsMerger.o
 rm -rf ./MatxsMergerTest.o
 rm -rf ./MatxsMergerTest.exe

 $CPP $CXXFLAGS    $TOP_DIR/MGXSUtils/MatxsUtils/MatxsObject.cpp \
                -o $TOP_DIR/MGXSUtils/MatxsUtils/MatxsObject.o
 $CPP $CXXFLAGS    $TOP_DIR/MGXSUtils/MatxsUtils/MatxsParser.cpp \
                -o $TOP_DIR/MGXSUtils/MatxsUtils/MatxsParser.o
 $CPP $CXXFLAGS    $TOP_DIR/MGXSUtils/MatxsUtils/MatxsWriter.cpp \
                -o $TOP_DIR/MGXSUtils/MatxsUtils/MatxsWriter.o
 $CPP $CXXFLAGS    $TOP_DIR/MGXSUtils/MatxsUtils/MatxsMerger.cpp \
                -o $TOP_DIR/MGXSUtils/MatxsUtils/MatxsMerger.o
 $CPP $CXXFLAGS    ./MatxsMergerTest.cpp -I.
 $CPP    $TOP_DIR/CommonUtils/VectorClearer.o \
         $TOP_DIR/CommonUtils/ErrorManager.o \
         $TOP_DIR/CommonUtils/StringUtils.o  \
         $TOP_DIR/CommonUtils/TabInterpolator.o \
         $TOP_DIR/CommonUtils/TabAdjuster.o \
         $TOP_DIR/CommonUtils/DigitAdjuster.o \
         $TOP_DIR/CommonUtils/VectorCopier.o \
         $TOP_DIR/MathUtils/ComplexErrorFunctionCalculator.o \
         $TOP_DIR/MathUtils/ComplexErrorFunctionCalculatorWithNjoyReconrFormula.o \
         $TOP_DIR/MathUtils/ComplexErrorFunctionCalculatorWithNjoyPurrFormula.o \
         $TOP_DIR/MathUtils/ComplexErrorFunctionCalculatorWithPadeApproximation.o \
         $TOP_DIR/MathUtils/MathUtils.o \
         $TOP_DIR/TabUtils/LinearizeTabData.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ResonanceData/BreitWignerDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ResonanceData/ReichMooreDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ResonanceData/AdlerAdlerDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ResonanceData/RMatrixLimitedDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ResonanceData/UnresolvedResonanceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ResonanceData/UnresolvedCrossSectionDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ResonanceData/UnresolvedProbabilityDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/GeneralDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/FissionDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/CrossSectionDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/EnergyAngularDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ResonanceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/PhotonDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ProductDistributionDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/ThermalScatterDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/RadioactiveProductDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/OtherNuclearDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataContainer/NuclearReactionDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceData/BreitWignerCovarianceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceData/BreitWignerCompactCovarianceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceData/ReichMooreCovarianceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceData/ReichMooreCompactCovarianceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceData/AdlerAdlerCovarianceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceData/RMatrixLimitedCovarianceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceData/RMatrixLimitedCompactCovarianceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceData/CompatibleResolvedResonanceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceData/UnresolvedResonanceCovarianceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceGeneralDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceCrossSectionDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceResonanceDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceFissionDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceEnergyAngularDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceRadioactiveProductDataContainer.o \
         $TOP_DIR/NuclearDataUtils/CovarianceDataContainer/CovarianceReactionDataContainer.o \
         $TOP_DIR/NuclearDataUtils/ProbabilityDataContainer/ProbabilityTableDataContainer.o \
         $TOP_DIR/NuclearDataUtils/ProbabilityDataContainer/ProbabilityDataContainer.o \
         $TOP_DIR/NuclearDataUtils/NuclearDataObject.o \
         $TOP_DIR/EndfUtils/EndfFileReader/EndfFileReader.o \
         $TOP_DIR/EndfUtils/EndfFileReader/MultiParser.o \
         $TOP_DIR/EndfUtils/EndfFileReader/StringConverter.o \
         $TOP_DIR/EndfUtils/EndfFileWriter/EndfFileWriter.o \
         $TOP_DIR/EndfUtils/OtherUtils/EndfTapeDivider.o   \
         $TOP_DIR/EndfUtils/MFxxMTyyyParser/MF01MT451Parser.o \
         $TOP_DIR/EndfUtils/GendfParser/GMF01MT451Parser.o \
         $TOP_DIR/EndfUtils/GendfParser/GMFxxParserBase.o \
         $TOP_DIR/EndfUtils/GendfParser/GMF03Parser.o \
         $TOP_DIR/EndfUtils/GendfParser/GMF05Parser.o \
         $TOP_DIR/EndfUtils/GendfParser/GMF06Parser.o \
         $TOP_DIR/EndfUtils/GendfParser/GMF13Parser.o \
         $TOP_DIR/EndfUtils/GendfParser/GMF16Parser.o \
         $TOP_DIR/EndfUtils/GendfParser/GendfParser.o \
         $TOP_DIR/EndfUtils/GendfWriter/GMFxxWriterBase.o \
         $TOP_DIR/EndfUtils/GendfWriter/GMF01MT451Writer.o \
         $TOP_DIR/EndfUtils/GendfWriter/GMF03Writer.o \
         $TOP_DIR/EndfUtils/GendfWriter/GMF05Writer.o \
         $TOP_DIR/EndfUtils/GendfWriter/GMF06Writer.o \
         $TOP_DIR/EndfUtils/GendfWriter/GMF13Writer.o \
         $TOP_DIR/EndfUtils/GendfWriter/GMF16Writer.o \
         $TOP_DIR/EndfUtils/GendfWriter/GendfWriter.o \
         $TOP_DIR/MGXSUtils/MatxsUtils/MatxsObject.o \
         $TOP_DIR/MGXSUtils/MatxsUtils/MatxsParser.o \
         $TOP_DIR/MGXSUtils/MatxsUtils/MatxsWriter.o \
         $TOP_DIR/MGXSUtils/MatxsUtils/MatxsMerger.o \
         MatxsMergerTest.o \
      -o MatxsMergerTest.exe \
      -lboost_timer \
      -lboost_system \
      -lboost_unit_test_framework

