#!/bin/csh

set PWD=`pwd`
set TOP_DIR=../..
set CPP=g++

foreach DIR ( ResonanceData )
  foreach CLASS ( `ls ${TOP_DIR}/NuclearDataUtils/NuclearDataContainer/${DIR}/*.cpp` )
    echo ${CLASS}
    set NAME = `basename ${CLASS} .cpp`
    rm -rf ${TOP_DIR}/NuclearDataUtils/NuclearDataContainer/${DIR}/${NAME}.o

    ${CPP} -c -Wall -O2 -I../../ ${CLASS} -o ${TOP_DIR}/NuclearDataUtils/NuclearDataContainer/${DIR}/${NAME}.o
  end
end

foreach CLASS ( `ls ${TOP_DIR}/NuclearDataUtils/NuclearDataContainer/*.cpp` \
                ${TOP_DIR}/NuclearDataUtils/NuclearDataContainer/NuclearReactionDataContainer.cpp )
  echo ${CLASS}
  set NAME = `basename ${CLASS} .cpp`
  rm -rf ${TOP_DIR}/NuclearDataUtils/NuclearDataContainer/${NAME}.o

  ${CPP} -c -Wall -O2 -I../../ ${CLASS} -o ${TOP_DIR}/NuclearDataUtils/NuclearDataContainer/${NAME}.o
end


