#include "ReconResonance/RmatrixLimited/endf/Numeric.h"
#include "ReconResonance/RmatrixLimited/numeric/Approx.h"

using namespace Numeric;



string parenthesize( const int a, const int b ) {

  stringstream ss;

    ss << '(' << a << ',' << b << ')';

  return ss.str();

}



void Remove( string* o, const string expression ) {

  if( o == NULL ) return;

  for( size_t c = o->find_first_of(expression); c != string::npos; c = o->find_first_of(expression) )

    o->erase(c,1);

  return;

}

/*
void RemoveSpace( string* o ) {

  if( o == NULL ) return;

  for( size_t c = o->find_first_of(" "); c != string::npos; c = o->find_first_of(" ") )

    o->erase(c,1);

  return;

}
*/

string endf( const int mat, const int mf, const int mt, int ns ) {

  stringstream ss;

    if( ns > 99999 ) ns = 99999;

    ss << setw(4) << right << mat
       << setw(2) << right <<  mf
       << setw(3) << right <<  mt
       << setw(5) << right <<  ns
       << endl;

  return ss.str();

}



string endf( const int mat = 0, const int mf = 0, const int mt = 0, int* ns = NULL ) {


  stringstream ss;

    if( ns != NULL && *ns >= 99999 ) *ns = -1;

    ( mat >    0 )  ?  ss << setw(4) << right <<   mat  :  ss << setw(4) << "";
    ( mf  >    0 )  ?  ss << setw(2) << right <<    mf  :  ss << setw(2) << "";
    ( mf  >    0 )  ?  ss << setw(3) << right <<    mt  :  ss << setw(3) << "";
    ( ns != NULL )  ?  ss << setw(5) << right << ++*ns  :  ss << setw(5) << "";

    ss << endl;

  return ss.str();

}


/*
string endf( const int _MAT = 0, const int _MF = 0, const int _MT = 0, int* _NS = NULL ) {

  string MAT( 4, ' ' );
  string  MF( 2, ' ' );
  string  MT( 3, ' ' );
  string  NS( 5, ' ' );

  if( _MAT >    0 ) MAT= str( format( "%4d" ) % _MAT );
  if( _MF  >    0 ) MF = str( format( "%2d" ) % _MF );
  if( _MT  >    0 ) MT = str( format( "%3d" ) % _MT );

  if( _NS != NULL ) {

    ++*_NS;

    //if( *_NS > 99999 ) NS = str( format( "%5d" ) % (*_NS-99999) );
    if( *_NS > 99999 ) NS = str( format( "%5d" ) % 99999 );
    else               NS = str( format( "%5d" ) % *_NS );

  }

  return MAT + MF + MT + NS + "\n";


  //++*_NS;
  //return str( format( "%4d%2d%3d%5d\n" ) % _MAT % _MF % _MT % *_NS );

}
*/




string endf( const int n ) {

  stringstream ss;

    ss << setw(11) << right << n;

  return ss.str();

}


string endf( const double x ) {

  double val( abs(x) ), base( 10.0 );
  int    exponent( 0 );

  if( x == 0.0 ) return " 0.000000+0";
  //if( x == 0.0 ) return " 0.0       ";

  while( true ) {

    if( 1.0 <= val && val < 10.0 ) break;

    if( 0.999999999999 <= val && val < 10.0 ) break;

    if( val < 1.0 ) val *=base;

    if( val >= 10.0 ) val /=base;

    exponent++;

  }


  int m(1);  if( exponent != 0 ) m = (int) log10( exponent ) + 1;

  int n = 10 - m -1;

  char pm('+');
    if( abs(x) > 1.0 ) pm = '+';
    else pm = '-';

    if( exponent == 0 ) pm = '+';


  stringstream ss;

    ( x > 0.0 ) ?  ss << ' ' <<  setprecision(n-1) << showpoint  << setfill('0') << left << val << pm
                             << setw(m) << setfill('0') << right << exponent
                :  ss << '-' <<  setprecision(n-1) << showpoint  << setfill('0') << left << val << pm
                             << setw(m) << setfill('0') << right << exponent;


  return ss.str();

}




/*
string endf( const double x ) {

  double val = abs(x);
  double base = 10.0;
  int exponent = 0;

  if( x == 0.0 ) return " 0.000000+0";
  //if( x == 0.0 ) return " 0.0       ";

  while( true ) {

    if( 1.0 <= val && val < 10.0 ) break;
    if( 0.999999999999 <= val && val < 10.0 ) break;


    if( val < 1.0 ) {
      val *=base;
    }

    if( val >= 10.0 ) {
      val /=base;
    }

    exponent++;

  }

//string str = lexical_cast<string>(base);

  //string str_val      = lexical_cast<string>(val);
  string str_exponent = lexical_cast<string>(exponent);

  //cout << "endf = " << str_val + "+" + str_exponent << endl;
  //cout << "exp = " << str_exponent.size() << endl;

  int n = 10 - str_exponent.size() -1 ;
  string str_size_val = lexical_cast<string>( n + 0.1*(n-2) );

//  cout << format( " %" + str_size_val + "f" ) % val << "+" + str_exponent << endl;
//  string str( format( " %" + str_size_val + "f" ) % val )  + "+" + str_exponent );

  string pm;
    if( abs(x) > 1.0 ) pm = "+";
    else pm = "-";

    if( exponent == 0 ) pm = "+";

//cout << str_exponent.size() << " " << str_size_val << endl;

//str_size_val = "8.6";
    if( x > 0.0 )
      return str( format( " %" + str_size_val + "f" ) % val ) + pm + str_exponent;
    if( x < 0.0 )
      return str( format( "-%" + str_size_val + "f" ) % val ) + pm + str_exponent;

}
*/

/* --------------- */
//  string to int  //
/* --------------- */
int int_endf( const string o ){

  return atoi( o.c_str() ); 

}



/* ------------------ */
//  string to double  //
/* ------------------ */


double dbl_endf( const string& o ){

  string value = o;

    Remove( &value, " " );

    if( value.find("E") != std::string::npos ) return atof( value.c_str() );
    if( value.find("e") != std::string::npos ) return atof( value.c_str() );

  int position = 0, value_size = value.length();

    for( int i=value_size-1; i>=0; i-- ) {

      if( value[i] == '+' || value[i] == '-' ) { position = i; break; }

    }

    if( position != 0 ) value.insert( position, "E" );

  return atof( value.c_str() );

}


/*
double dbl_endf( const string& o ){

  string value = o;

  if( value.find("E") != std::string::npos ) return atof( value.c_str() );

  int position = 0;

  int value_size;

  value_size = value.length();

  for( int i=0; i<value_size; i++ ) {

    if( value[i] == ' ' ) value[i] = '0';

  }

  if( value == "00.00000000" || value == "00000000000" ) return 0.0;


  for( int i=value_size-1; i<value_size; i-- ) {

    if( value[i] == '+' || value[i] == '-' ) { position = i; break;  }

  }

  if( position < value_size-8 ) {
    return atof( value.c_str() ); 
  }
  else{
    value.insert( position, "E" );
      return atof( value.c_str() ); 
  }

}
*/


/* ----------------- */
//  number of lines  //
/* ----------------- */
int num_of_lines( const int np, const int nds ) {

  return ( np%nds == 0 ) ? np/nds : np/nds+1;

}



void translate( ostream& os, const char* text, const int value, const int width ) {

   os << text  << fixed << right << setw(width) << setprecision(0) << value << "  ";  return;

}





/*
  ------------------------
        Class name
  ------------------------
*/
/*
template<class T> string Name( T* obj ) {

  const type_info& id = typeid( *obj );

  return id.name();

}
*/





/*
void Break( const string xline, vector<string>* v, const string delim ) {

 char* tp;

 v->clear();

 tp = strtok( (char*) xline.c_str(), (const char *) delim.c_str() );

 while( tp != (char*) NULL ) {

   v->push_back( tp );  tp = strtok( (char*) NULL, (const char*) delim.c_str() );

 }

 return;

}
*/

void Break( const string in, vector<string>* v, const string pattern ) {

  string xline(in);

    //remove_space( &xline );  do NOT so !!!

  v->clear();

  //char x[ xline  .size() ];   strcpy( x, xline  .c_str() );
  //char d[ pattern.size() ];   strcpy( d, pattern.c_str() );
  char* x = new char[ xline.size()   ];
  char* d = new char[ pattern.size() ];
  strcpy( x, xline  .c_str() );
  strcpy( d, pattern.c_str() );

  char* tp = strtok( x,d );

    while( tp != (char*) NULL ) {

      v->push_back( tp );  tp = strtok( (char*) NULL, d );

    }

  delete[] x;
  delete[] d;

  return;

}



vector<int> BreakNumbers( const string x ) {

 vector<int> a;  vector<string> v,vv;

   Break( x, &v, "," );

     for( int i=0; i<static_cast<int>(v.size()); i++ ) {

       Break( v.at(i), &vv, "~" );

       for( int ii=atoi(vv.front().c_str()); ii<=atoi(vv.back().c_str()); ii++ ) a.push_back(ii);

     }

 return a;

}


vector<float> BreakNumbers_f( const string x ) {

 vector<float> a;  vector<string> v;

   Break( x, &v, "," );

     for( int i=0; i<static_cast<int>(v.size()); i++ ) a.push_back( atof( v[i].c_str() ) );

 return a;

}




static const string a_text[288] = {

  "0    1 n   0          0       ",
  "1    1 H   99.985000  0.001000",
  "1    2 H    0.015000  0.001000",
  "2    3 He   0.000137  0.000003",
  "2    4 He  99.999863  0.000003",
  "3    6 Li   7.590000  0.040000",
  "3    7 Li  92.410000  0.040000",
  "4    9 Be 100.000000  0.000000",
  "5   10 B   19.800000  0.300000",
  "5   11 B   80.200000  0.300000",
  "6   12 C   98.890000  0.010000",
  "6   13 C    1.110000  0.010000",
  "7   14 N   99.634000  0.020000",
  "7   15 N    0.366000  0.020000",
  "8   16 O   99.762000  0.016000",
  "8   17 O    0.038000  0.001000",
  "8   18 O    0.200000  0.014000",
  "9   19 F  100.000000  0.000000",
  "10  20 Ne  90.480000  0.030000",
  "10  21 Ne   0.270000  0.010000",
  "10  22 Ne   9.250000  0.030000",
  "11  23 Na 100.000000  0.000000",
  "12  24 Mg  78.990000  0.040000",
  "12  25 Mg  10.000000  0.010000",
  "12  26 Mg  11.010000  0.030000",
  "13  27 Al 100.000000  0.000000",
  "14  28 Si  92.230000  0.019000",
  "14  29 Si   4.683000  0.008000",
  "14  30 Si   3.087000  0.005000",
  "15  31 P  100.000000  0.000000",
  "16  32 S   95.020000  0.090000",
  "16  33 S    0.750000  0.010000",
  "16  34 S    4.210000  0.080000",
  "16  36 S    0.020000  0.010000",
  "17  35 Cl  75.770000  0.040000",
  "17  37 Cl  24.230000  0.040000",
  "18  36 Ar   0.336500  0.003000",
  "18  38 Ar   0.063200  0.000500",
  "18  40 Ar  99.600300  0.003000",
  "19  39 K   93.258100  0.004400",
  "19  40 K    0.011700  0.000100",
  "19  41 K    6.730200  0.004400",
  "20  40 Ca  96.940000  0.160000",
  "20  42 Ca   0.647000  0.023000",
  "20  43 Ca   0.135000  0.010000",
  "20  44 Ca   2.090000  0.110000",
  "20  46 Ca   0.004000  0.003000",
  "20  48 Ca   0.187000  0.021000",
  "21  45 Sc 100.000000  0.000000",
  "22  46 Ti   8.250000  0.030000",
  "22  47 Ti   7.440000  0.020000",
  "22  48 Ti  73.720000  0.030000",
  "22  49 Ti   5.410000  0.020000",
  "22  50 Ti   5.180000  0.020000",
  "23  50 V    0.250000  0.002000",
  "23  51 V   99.750000  0.002000",
  "24  50 Cr   4.345000  0.013000",
  "24  52 Cr  83.789000  0.018000",
  "24  53 Cr   9.501000  0.017000",
  "24  54 Cr   2.365000  0.007000",
  "25  55 Mn 100.000000  0.000000",
  "26  54 Fe   5.845000  0.035000",
  "26  56 Fe  91.754000  0.036000",
  "26  57 Fe   2.119000  0.010000",
  "26  58 Fe   0.282000  0.004000",
  "27  59 Co 100.000000  0.000000",
  "28  58 Ni  68.077000  0.009000",
  "28  60 Ni  26.223000  0.008000",
  "28  61 Ni   1.140000  0.001000",
  "28  62 Ni   3.634000  0.002000",
  "28  64 Ni   0.926000  0.001000",
  "29  63 Cu  69.170000  0.030000",
  "29  65 Cu  30.830000  0.030000",
  "30  64 Zn  48.630000  0.600000",
  "30  66 Zn  27.900000  0.270000",
  "30  67 Zn   4.100000  0.130000",
  "30  68 Zn  18.750000  0.510000",
  "30  70 Zn   0.620000  0.030000",
  "31  69 Ga  60.108000  0.009000",
  "31  71 Ga  39.892000  0.009000",
  "32  70 Ge  20.370000  0.180000",
  "32  72 Ge  27.310000  0.260000",
  "32  73 Ge   7.760000  0.080000",
  "32  74 Ge  36.730000  0.150000",
  "32  76 Ge   7.830000  0.070000",
  "33  75 As 100.000000  0.000000",
  "34  74 Se   0.890000  0.040000",
  "34  76 Se   9.370000  0.290000",
  "34  77 Se   7.630000  0.160000",
  "34  78 Se  23.770000  0.280000",
  "34  80 Se  49.610000  0.410000",
  "34  82 Se   8.730000  0.220000",
  "35  79 Br  50.690000  0.070000",
  "35  81 Br  49.310000  0.070000",
  "36  78 Kr   0.350000  0.010000",
  "36  80 Kr   2.280000  0.060000",
  "36  82 Kr  11.580000  0.140000",
  "36  83 Kr  11.490000  0.060000",
  "36  84 Kr  57.000000  0.040000",
  "36  86 Kr  17.300000  0.220000",
  "37  85 Rb  72.170000  0.020000",
  "37  87 Rb  27.830000  0.020000",
  "38  84 Sr   0.560000  0.010000",
  "38  86 Sr   9.860000  0.010000",
  "38  87 Sr   7.000000  0.010000",
  "38  88 Sr  82.580000  0.010000",
  "39  89 Y  100.000000  0.000000",
  "40  90 Zr  51.450000  0.400000",
  "40  91 Zr  11.220000  0.050000",
  "40  92 Zr  17.150000  0.080000",
  "40  94 Zr  17.380000  0.280000",
  "40  96 Zr   2.800000  0.090000",
  "41  93 Nb 100.000000  0.000000",
  "42  92 Mo  14.840000  0.350000",
  "42  94 Mo   9.250000  0.120000",
  "42  95 Mo  15.920000  0.130000",
  "42  96 Mo  16.680000  0.020000",
  "42  97 Mo   9.550000  0.080000",
  "42  98 Mo  24.130000  0.310000",
  "42 100 Mo   9.630000  0.230000",
  "44  96 Ru   5.540000  0.140000",
  "44  98 Ru   1.870000  0.030000",
  "44  99 Ru  12.760000  0.140000",
  "44 100 Ru  12.600000  0.070000",
  "44 101 Ru  17.060000  0.020000",
  "44 102 Ru  31.550000  0.140000",
  "44 104 Ru  18.620000  0.270000",
  "45 103 Rh 100.000000  0.000000",
  "46 102 Pd   1.020000  0.010000",
  "46 104 Pd  11.140000  0.080000",
  "46 105 Pd  22.330000  0.080000",
  "46 106 Pd  27.330000  0.030000",
  "46 108 Pd  26.460000  0.090000",
  "46 110 Pd  11.720000  0.090000",
  "47 107 Ag  51.839000  0.008000",
  "47 109 Ag  48.161000  0.008000",
  "48 106 Cd   1.250000  0.060000",
  "48 108 Cd   0.890000  0.030000",
  "48 110 Cd  12.490000  0.180000",
  "48 111 Cd  12.800000  0.120000",
  "48 112 Cd  24.130000  0.210000",
  "48 113 Cd  12.220000  0.120000",
  "48 114 Cd  28.730000  0.420000",
  "48 116 Cd   7.490000  0.180000",
  "49 113 In   4.290000  0.050000",
  "49 115 In  95.710000  0.050000",
  "50 112 Sn   0.970000  0.010000",
  "50 114 Sn   0.660000  0.010000",
  "50 115 Sn   0.340000  0.010000",
  "50 116 Sn  14.540000  0.090000",
  "50 117 Sn   7.680000  0.070000",
  "50 118 Sn  24.220000  0.090000",
  "50 119 Sn   8.590000  0.040000",
  "50 120 Sn  32.580000  0.090000",
  "50 122 Sn   4.630000  0.030000",
  "50 124 Sn   5.790000  0.050000",
  "51 121 Sb  57.210000  0.050000",
  "51 123 Sb  42.790000  0.050000",
  "52 120 Te   0.090000  0.010000",
  "52 122 Te   2.550000  0.120000",
  "52 123 Te   0.890000  0.030000",
  "52 124 Te   4.740000  0.140000",
  "52 125 Te   7.070000  0.150000",
  "52 126 Te  18.840000  0.250000",
  "52 128 Te  31.740000  0.080000",
  "52 130 Te  34.080000  0.620000",
  "53 127 I  100.000000  0.000000",
  "54 124 Xe   0.095000  0.003000",
  "54 126 Xe   0.089000  0.001000",
  "54 128 Xe   1.910000  0.022000",
  "54 129 Xe  26.400000  0.180000",
  "54 130 Xe   4.071000  0.053000",
  "54 131 Xe  21.232000  0.062000",
  "54 132 Xe  26.909000  0.068000",
  "54 134 Xe  10.436000  0.029000",
  "54 136 Xe   8.857000  0.033000",
  "55 133 Cs 100.000000  0.000000",
  "56 130 Ba   0.106000  0.001000",
  "56 132 Ba   0.101000  0.001000",
  "56 134 Ba   2.417000  0.018000",
  "56 135 Ba   6.592000  0.012000",
  "56 136 Ba   7.854000  0.024000",
  "56 137 Ba  11.232000  0.024000",
  "56 138 Ba  71.698000  0.042000",
  "57 138 La   0.090000  0.001000",
  "57 139 La  99.910000  0.001000",
  "58 136 Ce   0.185000  0.002000",
  "58 138 Ce   0.251000  0.002000",
  "58 140 Ce  88.450000  0.018000",
  "58 142 Ce  11.114000  0.017000",
  "59 141 Pr 100.000000  0.000000",
  "60 142 Nd  27.200000  0.500000",
  "60 143 Nd  12.200000  0.200000",
  "60 144 Nd  23.800000  0.300000",
  "60 145 Nd   8.300000  0.100000",
  "60 146 Nd  17.200000  0.300000",
  "60 148 Nd   5.700000  0.100000",
  "60 150 Nd   5.600000  0.200000",
  "62 144 Sm   3.070000  0.070000",
  "62 147 Sm  14.990000  0.180000",
  "62 148 Sm  11.240000  0.100000",
  "62 149 Sm  13.820000  0.070000",
  "62 150 Sm   7.380000  0.010000",
  "62 152 Sm  26.750000  0.160000",
  "62 154 Sm  22.750000  0.290000",
  "63 151 Eu  47.810000  0.030000",
  "63 153 Eu  52.190000  0.030000",
  "64 152 Gd   0.200000  0.010000",
  "64 154 Gd   2.180000  0.030000",
  "64 155 Gd  14.800000  0.120000",
  "64 156 Gd  20.470000  0.090000",
  "64 157 Gd  15.650000  0.020000",
  "64 158 Gd  24.840000  0.070000",
  "64 160 Gd  21.860000  0.190000",
  "65 159 Tb 100.000000  0.000000",
  "66 156 Dy   0.060000  0.010000",
  "66 158 Dy   0.100000  0.010000",
  "66 160 Dy   2.340000  0.080000",
  "66 161 Dy  18.910000  0.240000",
  "66 162 Dy  25.510000  0.260000",
  "66 163 Dy  24.900000  0.160000",
  "66 164 Dy  28.180000  0.370000",
  "67 165 Ho 100.000000  0.000000",
  "68 162 Er   0.139000  0.005000",
  "68 164 Er   1.601000  0.003000",
  "68 166 Er  33.503000  0.036000",
  "68 167 Er  22.869000  0.009000",
  "68 168 Er  26.978000  0.018000",
  "68 170 Er  14.910000  0.036000",
  "69 169 Tm 100.000000  0.000000",
  "70 168 Yb   0.130000  0.010000",
  "70 170 Yb   3.040000  0.150000",
  "70 171 Yb  14.280000  0.570000",
  "70 172 Yb  21.830000  0.670000",
  "70 173 Yb  16.130000  0.270000",
  "70 174 Yb  31.830000  0.920000",
  "70 176 Yb  12.760000  0.410000",
  "71 175 Lu  97.410000  0.020000",
  "71 176 Lu   2.590000  0.020000",
  "72 174 Hf   0.160000  0.010000",
  "72 176 Hf   5.260000  0.070000",
  "72 177 Hf  18.600000  0.090000",
  "72 178 Hf  27.280000  0.070000",
  "72 179 Hf  13.620000  0.020000",
  "72 180 Hf  35.080000  0.160000",
  "73 180 Ta   0.012000  0.002000",
  "73 181 Ta  99.988000  0.002000",
  "74 180 W    0.120000  0.010000",
  "74 182 W   26.500000  0.160000",
  "74 183 W   14.310000  0.040000",
  "74 184 W   30.640000  0.020000",
  "74 186 W   28.430000  0.190000",
  "75 185 Re  37.400000  0.020000",
  "75 187 Re  62.600000  0.020000",
  "76 184 Os   0.020000  0.010000",
  "76 186 Os   1.590000  0.030000",
  "76 187 Os   1.600000  0.300000",
  "76 188 Os  13.290000  0.080000",
  "76 189 Os  16.210000  0.050000",
  "76 190 Os  26.360000  0.020000",
  "76 192 Os  40.930000  0.190000",
  "77 191 Ir  37.300000  0.200000",
  "77 193 Ir  62.700000  0.200000",
  "78 190 Pt   0.014000  0.001000",
  "78 192 Pt   0.782000  0.007000",
  "78 194 Pt  32.967000  0.099000",
  "78 195 Pt  33.832000  0.010000",
  "78 196 Pt  25.242000  0.041000",
  "78 198 Pt   7.163000  0.055000",
  "79 197 Au 100.000000  0.000000",
  "80 196 Hg   0.150000  0.010000",
  "80 198 Hg   9.970000  0.200000",
  "80 199 Hg  16.870000  0.220000",
  "80 200 Hg  23.100000  0.190000",
  "80 201 Hg  13.180000  0.090000",
  "80 202 Hg  29.860000  0.260000",
  "80 204 Hg   6.870000  0.150000",
  "81 203 Tl  29.524000  0.014000",
  "81 205 Tl  70.476000  0.014000",
  "82 204 Pb   1.400000  0.100000",
  "82 206 Pb  24.100000  0.100000",
  "82 207 Pb  22.100000  0.100000",
  "82 208 Pb  52.400000  0.100000",
  "83 209 Bi 100.000000  0.000000",
  "90 232 Th 100.000000  0.000000",
  "92 234 U    0.005400  0.000500",
  "92 235 U    0.720400  0.000600",
  "92 238 U   99.274200  0.001000"

};

double NaturalAbundance( const int za ) {

  int z(za/1000), a(za%1000);

    for( int i=0; i<288; i++ ) {

      vector<string> b;  Break( a_text[i], &b, " " );

      if( atoi( b[0].c_str() ) == z && atoi( b[1].c_str() ) == a )

        return atof( b[3].c_str() ) /100.;

    }

  return 0.0;

}

vector<double> NaturalIsotopes( const int z ) {

  vector<double> a;

    for( int i=0; i<288; i++ ) {

      vector<string> b;  Break( a_text[i], &b, " " );

      if( atoi( b[0].c_str() ) == z )

        a.push_back( 1000*atof( b[0].c_str() ) + atof( b[1].c_str() ) );

    }

  return a;

}
