#include "ReconResonance/RmatrixLimited/endf/TOF.h"

//ClassImp( TOF );

TOF::TOF() : m(1.00866*931.494*1.e+6), l(0.), dl(0.), dt(0.) {}

TOF::TOF( const double length, const double dlength, const double dtime ) {

  m = 1.00866 *931.494 * 1.e+6;

  this->Set( length, dlength, dtime );

}

TOF::~TOF(){}

/* Set values */

TOF* TOF::Set( const double length, const double dlength, const double dtime ) {

  l = length;  dl = dlength;  dt = dtime;  return this;

}


/* Time of flight */

double TOF::t( const double e ) const {

  return l/0.299792458/sqrt( 1.- pow( m/(e+m), 2. ) );

}



/* Energy resolution */

double TOF::Resolution( const double e ) const {

  return (e+m) * ( pow( (e+m)/m, 2. ) -1. ) * sqrt(  pow( dl/l, 2. ) + pow( dt/this->t(e), 2. ) );

}



bool TOF::is_ready() const {

  if( m == 0. ) return false;
  if( l == 0. ) return false;
  if( dl == 0. && dt == 0. ) return false;

  return true;

}
